#include <pic.h>

	/* This routine is used by printf to push characters */
	/* out the serial port                               */
	
void putch(unsigned char ByteVal)
{
#asm
WaitSendByte:
    btfss	_PIR1,4
	  goto	WaitSendByte
	movwf	_TXREG
#endasm
}

	/* Set up serial port to run at 115200 baud */
	
void InitRS232(void)
{
	RP0 = 0;
	RP1 = 0;		// Select Bank 0 registers
	RP0 = 1;		// Select Bank 1 registers
	TRISC7 = 1;		// PORTC[RX] is Input
	TRISC6 = 0; 	// PORTC[TX] is Output
	SPBRG = 10;		// Set baud to 115200
	TXSTA = 0x24;	// Set TXEN and BRGH to 1
	RP0 = 0;		// Select Bank 0 registers
	RCSTA = 0x90;	// Set SPEN and CREN to 1

#ifdef USE_ASM
#asm
	bcf	_STATUS,5
	bcf	_STATUS,6		; Select Bank 0	
	bsf	_STATUS,5		; Select Bank 1 registers        	
	bsf	_TRISC,7        ; PORTC[RX] is Input
	bcf	_TRISC,6        ; PORTC[TX] is Output
	movlw	10
	movwf	_SPBRG		; Set baud to 115200
	movlw	0x24		; (1<<TXEN)|(1<<BRGH)
	movwf	_TXSTA		; Set transmit mode
	/*
//#ifdef INT_RS232
	movlw	(1<<TXIE)|(1<<RXIE)
	iorwf	PIE1			; Enable Transmit and receive interrupts
//#endif
*/
	bcf	_STATUS,5		; Select Bank 0
	movlw	0x90		; (1<<SPEN)|(1<<CREN)
	movwf	_RCSTA		; Set receive mode 
#endasm
#endif
}
